﻿using ProjectLainer.DrawningObjects;
using ProjectLainer.Entities;

namespace ProjectLainer.Generics
{
    internal class LainerCompareByColor : IComparer<DrawingEntity?>
    {
        public int Compare(DrawingEntity? x, DrawingEntity? y)
        {
            if (x == null || x.EntityLainer == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityLainer == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            //по цвету
            var colorCompare = x.EntityLainer.BodyColor.Name.CompareTo(y.EntityLainer.BodyColor.Name);
            if(colorCompare != 0)
            {
                return colorCompare;
            }
            //по скорости
            var speedCompare = x.EntityLainer.Speed.CompareTo(y.EntityLainer.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            //по весу
            return x.EntityLainer.Weight.CompareTo(y.EntityLainer.Weight);
        }
    }
}
