﻿using ProjectLainer.DrawningObjects;
namespace ProjectLainer.Generics
{
    internal class LainerCompareByType : IComparer<DrawingEntity?>
    {
        public int Compare(DrawingEntity? x, DrawingEntity? y)
        {
            if (x == null || x.EntityLainer == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityLainer == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare = x.EntityLainer.Speed.CompareTo(y.EntityLainer.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityLainer.Weight.CompareTo(y.EntityLainer.Weight);
        }
    }
}
